%if 0%{fedora} >= 17
%if 0%{?fedora} < 19
%define	rubyabi		1.9.1
%endif
%else
%define	ruby_sitelib		%(ruby -rrbconfig -e "puts Config::CONFIG['sitelibdir']")
%define	ruby_sitearch		%(ruby -rrbconfig -e "puts Config::CONFIG['sitearchdir']")
%define	rubyabi		1.8
%endif

%define	gem_name		ruby-opengl

# examples/OrangeBook/: BSD
# examples/NeHe: KILLED (license unclear)
# examples/RedBook/ SGI = MIT
# examples/misc/OGLBench.rb: GPL+ or Artistic
# examples/misc/fbo_test.rb ??? KILLED
# examples/misc/trislam.rb: GPL+ or Artistic

Summary:	OpenGL Interface for Ruby
Name:		rubygem-%{gem_name}
Version:	0.60.1
Release:	14%{?dist}
Group:		Development/Languages
License:	MIT
URL:		http://ruby-opengl.rubyforge.org/
#Source0:	http://gems.rubyforge.org/gems/%{gem_name}-%{version}.gem
# Source0:	https://rubygems.org/gems/%%{gem_name}-%%{version}.gem
# The above gem file contains files with unclear license,
# we use a regenerated gem as a Source0 with such files
# removed.
# Source0 is generated using Source1.  
Source0:	%{gem_name}-%{version}-clean.gem
Source1:	create-clean-ruby-opengl-gem.sh
Patch0:	rubygem-ruby-opengl-0.60.1-ruby19-macro.patch
Patch1:	rubygem-ruby-opengl-0.60.1-newrake.patch

BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
%if 0%{?fedora} >= 19
Requires:	ruby(release)
BuildRequires:	ruby(release)
%else
Requires:	ruby(abi) = %{rubyabi}
Requires:	ruby 
BuildRequires:	ruby(abi) = %{rubyabi}
BuildRequires:	ruby 
%endif

BuildRequires:	freeglut-devel
BuildRequires:	libGL-devel
BuildRequires:	libGLU-devel
BuildRequires:	rubygems-devel
BuildRequires:	rubygem(mkrf)
BuildRequires:	rubygem(rake)
BuildRequires:	ruby-devel
Requires:	ruby(rubygems)
Provides:	rubygem(%{gem_name}) = %{version}-%{release}
%if %{fedora} >= 17
Obsoletes:	ruby-%{gem_name} <= %{version}-%{release}
Provides:	ruby-%{gem_name} = %{version}-%{release}
Provides:	ruby(%{gem_name}) = %{version}-%{release}
%endif

%description
ruby-opengl consists of Ruby extension modules that are bindings 
for the OpenGL, GLU, and GLUT libraries. It is intended to be 
a replacement for -- and uses the code from -- Yoshi's ruby-opengl.

%package	doc
Summary:	Documentation for %{name}
Group:		Documentation
# Directory ownership issue
Requires:	%{name} = %{version}-%{release}

%description	doc
This package contains documentation for %{name}.

%package	-n ruby-opengl
Summary:	Non-Gem support package for %{gem_name}
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}
Provides:	ruby(opengl) = %{version}-%{release}

%description	-n ruby-opengl
This package provides non-Gem support for %{gem_name}.

%prep
%setup -q -c -T
# Gem repack
TOPDIR=$(pwd)
mkdir tmpunpackdir
pushd tmpunpackdir

gem unpack %{SOURCE0}
cd %{gem_name}-%{version}-clean
gem specification -l --ruby %{SOURCE0} > %{gem_name}.gemspec

%patch0 -p1 -b .obsolete
%patch1 -p1 -b .rake
# mkrf, rake not needed on runtime
sed -i -e 's|runtime_dependency|development_dependency|' \
	%{gem_name}.gemspec

gem build %{gem_name}.gemspec
mv %{gem_name}-%{version}.gem $TOPDIR

popd
rm -rf tmpunpackdir

%build
mkdir -p ./%{gem_dir}
export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
# CONFIGURE_ARGS does not work well, tweak
# rbconfig.rb directly
%if 0%{?fedora} >= 17
cat %{_libdir}/ruby/rbconfig.rb | \
    sed -e '/CFLAGS/s|-Wall|-Wall -Werror-implicit-function-declaration|' > \
    rbconfig.rb
export RUBYLIB=$(pwd)
%endif

export rake="rake --trace"
%gem_install

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{gem_dir}
cp -a ./%{gem_dir}/* %{buildroot}%{gem_dir}

%if 0%{?fedora} >= 17
mkdir -p %{buildroot}%{gem_extdir_mri}/lib
mv %{buildroot}%{gem_instdir}/lib/*.so %{buildroot}%{gem_extdir_mri}/lib
%else
mkdir -p %{buildroot}%{ruby_sitearch}
mv %{buildroot}%{gem_instdir}/lib/*.so %{buildroot}%{ruby_sitearch}
%endif

# cleanups
pushd %{buildroot}%{gem_instdir}
rm -rf \
	doc/build_install.txt \
	ext/ \

grep -rlv '^#!/' examples/ | grep 'rb$' | xargs chmod 0644
grep -rl '^#!/' examples/ | grep 'rb$' | xargs chmod 0755
find . -type f | xargs file | sed -n -e '/CRLF/s|:.*||p' | xargs sed -i -e 's|\r||'
popd

# The following method is completely copied from rubygem-gettext
# spec file
#
# Create symlinks

create_symlink_rec(){

ORIGBASEDIR=$1
TARGETBASEDIR=$2

## First calculate relative path of ORIGBASEDIR 
## from TARGETBASEDIR
TMPDIR=$TARGETBASEDIR
BACKDIR=
DOWNDIR=
num=0
nnum=0
while true
do
	num=$((num+1))
	TMPDIR=$(echo $TMPDIR | sed -e 's|/[^/][^/]*$||')
	DOWNDIR=$(echo $ORIGBASEDIR | sed -e "s|^$TMPDIR||")
	if [ x$DOWNDIR != x$ORIGBASEDIR ]
	then
		nnum=0
		while [ $nnum -lt $num ]
		do
			BACKDIR="../$BACKDIR"
			nnum=$((nnum+1))
		done
		break
	fi
done

RELBASEDIR=$( echo $BACKDIR/$DOWNDIR | sed -e 's|//*|/|g' )

## Next actually create symlink
pushd %{buildroot}/$ORIGBASEDIR
find . -type f | while read f
do
	DIRNAME=$(dirname $f)
	BACK2DIR=$(echo $DIRNAME | sed -e 's|/[^/][^/]*|/..|g')
	mkdir -p %{buildroot}${TARGETBASEDIR}/$DIRNAME
	LNNAME=$(echo $BACK2DIR/$RELBASEDIR/$f | \
		sed -e 's|^\./||' | sed -e 's|//|/|g' | \
		sed -e 's|/\./|/|' )
	ln -s -f $LNNAME %{buildroot}${TARGETBASEDIR}/$f
done
popd

}

%if 0%{?fedora} < 17
create_symlink_rec %{gem_instdir}/lib %{ruby_sitelib}
%endif

%clean
rm -rf %{buildroot}

%check
# Need X, disabling
exit 0

%files
%defattr(-,root, root,-)
%if 0%{?fedora} >= 17
%dir %{gem_extdir_mri}
%dir %{gem_extdir_mri}/lib
%{gem_extdir_mri}/lib/*.so
%else
%{ruby_sitearch}/*.so
%endif
%dir	%{gem_instdir}/
%doc	%{gem_instdir}/doc/
%{gem_instdir}/lib/
%{gem_dir}/cache/%{gem_name}-%{version}.gem
%{gem_dir}/specifications/%{gem_name}-%{version}.gemspec

%files	doc
%defattr(-,root,root,-)
%{gem_dir}/doc/%{gem_name}-%{version}/
%{gem_instdir}/Rakefile
%{gem_instdir}/examples/
%{gem_instdir}/test/

%if 0%{?fedora} < 17
%files	-n ruby-opengl
%defattr(-,root,root,-)
%{ruby_sitelib}/opengl.rb
%endif

%changelog
* Fri Nov  1 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 0.60.1-14
- Remove files with unclear licenses

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.60.1-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Mar  7 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 0.60.1-12
- F-19: Rebuild for ruby 2.0.0

* Thu Feb  7 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 0.60.1-11
- Patch for new rake

* Thu Feb  7 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 0.60.1-10
- Don't use STR2CSTR
- Make unneeded deps out of runtime

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.60.1-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Mon Feb  6 2012 Mamoru Tasaka <mtasaka@fedoraproject.org>  - 0.60.1-7
- F-17: rebuild against f17-ruby

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.60.1-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.60.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Nov 11 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.60.1-4
- Include ri files

* Sat Jul 25 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.60.1-3
- F-12: Mass rebuild

* Fri Jun 27 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.60.1-2
- Initial packaging
